#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <XSP2lib.H>
#include "main.h"
#include "enemy.h"
#include "fxsp2lib.h"
#include "parts.h"

#define ENEMY_MAX	256	/* ő吔 */


#define P1_K	0.5		/* ΂˒萔iEp[cj */
#define P1_M	0.2		/* CviEp[cj */
#define P1_V	0.5		/* xȉȂ玟ցiEp[cj */
#define P1_L	0.4		/* WȉȂ玟ցiEp[cj */

#define P2_K	2.9		/* ΂˒萔iE㏬p[cj */
#define P2_M	0.06		/* CviE㏬p[cj */
#define P2_V	0.1		/* xȉȂ玟ցiE㏬p[cj */
#define P2_L	0.1		/* WȉȂ玟ցiE㏬p[cj */
#define P2_S	22		/* seq_counter ɂȂ瓮JniE㏬p[cj */

#define P3_K	1.5		/* ΂˒萔iEp[cj */
#define P3_M	0.06		/* CviEp[cj */
#define P3_V	0.1		/* xȉȂ玟ցiEp[cj */
#define P3_L	0.1		/* WȉȂ玟ցiEp[cj */
#define P3_S	40		/* seq_counter ɂȂ瓮JniEp[cj */


static ENEMY *enemy_top,	/* gp̃[ÑXg */
 *enemy_null_top,		/* ̃[ÑXg */
 *enemy_end;			/* gp[ÑXg̖ */

static ENEMY enemy[ENEMY_MAX];	/* [N */

extern char end_of_data;

typedef struct _spwork {
	signed short x, y;	/* W */
	unsigned short pt;	/* XvCgp^[mD */
	unsigned short info;	/* ]R[hEFEDx\킷f[^ */
} SPWORK;


SPWORK spwork;



int EnemyInit0 (void)
{
	int i;

    /* XgȂ */
	enemy_top = NULL;
	enemy_end = NULL;
	enemy_null_top = enemy;
	for (i = 0; i < ENEMY_MAX; i++)
		enemy[i].next = &enemy[i + 1];

	enemy[ENEMY_MAX - 1].next = NULL;

	return (0);
}



void EnemyInit (unsigned short type, unsigned short info,
		signed short ox, signed short oy, ENEMY * parent)
{
	ENEMY *p;

	if (enemy_null_top == NULL) {
		printf ("[Ntł\n");
		return;		/* 󂫂̃[NȂiLN^[I[o[j */
	}
    /* Xg̖ɐVm[hǉ */
	p = enemy_null_top;
	enemy_null_top = p->next;
	if (enemy_top == NULL)
		enemy_top = p;
	else
		enemy_end->next = p;
	p->next = NULL;
	enemy_end = p;

	p->type = type;
	p->info = info;
	p->ox = ox;
	p->oy = oy;
	p->x = 0;
	p->y = 0;
	p->parent = parent;

	p->lx = 0.0;
	p->ly = 0.0;
	p->lz = 0.0;
	p->vx = 0.0;
	p->vy = 0.0;
	p->vz = 0.0;
	p->cyc = 0;
	p->cyc1 = 0;

	switch (p->type) {
	case 0:		/* { */
		EnemyInit (1, 0x0432, -48, 16, p);	/* p[c */
		EnemyInit (2, 0x0432, 32, 16, p);	/* Ep[c */
		EnemyInit (3, 0x043a, -32, 0, p);	/* ㏬p[c */
		EnemyInit (4, 0x043a, 32, 0, p);	/* E㏬p[c */
		break;
	case 1:		/* p[c */
		EnemyInit (5, 0x043a, 16, 16, p);	/* p[c */
		break;
	case 2:		/* Ep[c */
		EnemyInit (6, 0x043a, -16, 16, p);	/* Ep[c */
		break;
	case 3:		/* ㏬p[c */
		break;
	case 4:		/* E㏬p[c */
		break;
	case 5:		/* p[c */
		break;
	case 6:		/* Ep[c */
		break;
	case 7:		/* p[c */
		break;
	default:
		printf ("enemy_move() : oOĂ܂\n");
		break;
	}
}


/* ̃XvCgō\Ăp[cP̃XvCg܂Ƃ߂ĕ\ */
static void DispSp (ENEMY * p, short sp_num, PARTS_TABLE * parts_table)
{
	short h;

	for (h = 0; h < sp_num; h++) {
		p->x = p->lx + p->ox;
		p->y = p->ly + p->oy;
		if (p->parent != NULL) {
			spwork.x = p->x + p->parent->x + parts_table[h].x;
			spwork.y = p->y + p->parent->y + parts_table[h].y;
		} else {
			spwork.x = p->x + parts_table[h].x;
			spwork.y = p->y + parts_table[h].y;
		}
		spwork.pt = parts_table[h].pt;
		spwork.info = p->info;

		spwork.x += (128 + 16);	/* \pɕ␳ */
		spwork.y += (128 + 16);
		xsp_set_st (&spwork);
		fxsp_set_st (&spwork);
		spwork.x -= (128 + 16);
		spwork.y -= (128 + 16);
	}
}



void EnemyMove (void)
{
	ENEMY *p, *q;

	p = enemy_top;
	q = NULL;
	while (p != NULL) {
		char erase_flag = 0;

		switch (p->type) {
		case 0:	/* { */
			DispSp (p, 36, parts0_table);
			break;
		case 1:	/* p[c */
			switch (p->cyc) {
			case 0:
				if (seq_counter == 2)
					p->cyc = 1;
				break;
			case 1:/* xIɗ */
				if (p->vx > -3.0)
					p->vx -= 0.5;
				p->lx += p->vx;
				if (p->lx < -8.0) {
					p->cyc++;	/*  */
					p->lx = -8.0;
					p->ox += p->lx;
					p->oy += p->ly;
					p->lx = 0.0;	/* x͂_ɂȂ */
					p->ly = 0.0;
				}
				break;
			case 2:/* ΂ːU */
				p->vx -= p->lx * P1_K;
			    /* C */
				if (p->vx > 0)
					p->vx -= P1_M;
				else
					p->vx += P1_M;
				p->lx += p->vx;
				if ((fabs (p->vx) < P1_V) && (fabs (p->lx) < P1_L)) {
					p->cyc++;	/*  */
					p->lx = 0.0;
					p->ly = 0.0;
					p->vx = 0.0;
					p->vy = 0.0;
				}
				break;
			default:
				break;
			}
			DispSp (p, 25, parts1_table);
			break;
		case 2:	/* Ep[c */
			switch (p->cyc) {
			case 0:
				if (seq_counter == 2)
					p->cyc = 1;
				break;
			case 1:/* xIɗ */
				if (p->vx < 3.0)
					p->vx += 0.5;
				p->lx += p->vx;
				if (p->lx > 8.0) {
					p->cyc++;	/*  */
					p->lx = 8.0;
					p->ox += p->lx;
					p->oy += p->ly;
					p->lx = 0.0;	/* x͂_ɂȂ */
					p->ly = 0.0;
				}
				break;
			case 2:/* ΂ːU */
				p->vx -= p->lx * P1_K;
			    /* C */
				if (p->vx > 0)
					p->vx -= P1_M;
				else
					p->vx += P1_M;
				p->lx += p->vx;
				if ((fabs (p->vx) < P1_V) && (fabs (p->lx) < P1_L)) {
					p->cyc++;	/*  */
					p->lx = 0.0;
					p->ly = 0.0;
					p->vx = 0.0;
					p->vy = 0.0;
				}
				break;
			default:
				break;
			}
			DispSp (p, 25, parts2_table);
			break;
		case 3:	/* ㏬p[c */
			switch (p->cyc) {
			case 0:
				if (seq_counter > P2_S) {
					p->cyc++;	/*  */
					p->lz = 0.0;	/* n_ 0.0, I_ 1.0 */
					p->vz = 0.0;
				}
				break;
			case 1:/* xIɗ */
				if (p->vz < 0.20)
					p->vz += 0.10;
				p->lz += p->vz;
				p->lx = (301 - 305) * p->lz;
				p->ly = (125 - 140) * p->lz;
				if (p->lz > 1.0) {
					p->cyc++;	/*  */
					p->lz = 0.0;
					p->lx = 0.0;	/* x͂_ɂȂ */
					p->ly = 0.0;
					p->ox += (301 - 305);
					p->oy += (125 - 140);
				}
				break;
			case 2:/* ΂ːU */
				p->vz -= p->lz * P2_K;
			    /* C */
				if (p->vz > 0)
					p->vz -= P2_M;
				else
					p->vz += P2_M;
				p->lz += p->vz;
				p->lx = (301 - 305) * p->lz;
				p->ly = (125 - 140) * p->lz;
				if ((fabs (p->vz) < P2_V) && (fabs (p->lz) < P2_L)) {
					p->cyc++;	/*  */
					p->lx = 0.0;
					p->ly = 0.0;
					p->vx = 0.0;
					p->vy = 0.0;
				}
				break;
			default:
				break;
			}
			DispSp (p, 9, parts3_table);
			break;
		case 4:	/* E㏬p[c */
			switch (p->cyc) {
			case 0:
				if (seq_counter > P2_S) {
					p->cyc++;	/*  */
					p->lz = 0.0;	/* n_ 0.0, I_ 1.0 */
					p->vz = 0.0;
				}
				break;
			case 1:/* xIɗ */
				if (p->vz < 0.20)
					p->vz += 0.10;
				p->lz += p->vz;
				p->lx = -(301 - 305) * p->lz;
				p->ly = (125 - 140) * p->lz;
				if (p->lz > 1.0) {
					p->cyc++;	/*  */
					p->lz = 0.0;
					p->lx = 0.0;	/* x͂_ɂȂ */
					p->ly = 0.0;
					p->ox -= (301 - 305);
					p->oy = (125 - 140);
				}
				break;
			case 2:/* ΂ːU */
				p->vz -= p->lz * P2_K;
			    /* C */
				if (p->vz > 0)
					p->vz -= P2_M;
				else
					p->vz += P2_M;
				p->lz += p->vz;
				p->lx = -(301 - 305) * p->lz;
				p->ly = (125 - 140) * p->lz;
				if ((fabs (p->vz) < P2_V) && (fabs (p->lz) < P2_L)) {
					p->cyc++;	/*  */
					p->lx = 0.0;
					p->ly = 0.0;
					p->vx = 0.0;
					p->vy = 0.0;
				}
				break;
			default:
				break;
			}
			DispSp (p, 9, parts4_table);
			break;
		case 5:	/* p[c */
			switch (p->cyc) {
			case 0:
				if (seq_counter > P3_S) {
					p->cyc++;	/*  */
					p->lz = 0.0;	/* n_ 0.0, I_ 1.0 */
					p->vz = 0.0;
				}
				break;
			case 1:/* xIɗ */
				if (p->vz < 0.20)
					p->vz += 0.10;
				p->lz += p->vz;
				p->lx = (301 - 320) * p->lz;
				p->ly = (184 - 179) * p->lz;
				if (p->lz > 1.0) {
					p->cyc++;	/*  */
					p->lz = 0.0;
					p->lx = 0.0;	/* x͂_ɂȂ */
					p->ly = 0.0;
					p->ox += (301 - 320);
					p->oy += (184 - 179);
				}
				break;
			case 2:/* ΂ːU */
				p->vz -= p->lz * P3_K;
			    /* C */
				if (p->vz > 0)
					p->vz -= P3_M;
				else
					p->vz += P3_M;
				p->lz += p->vz;
				p->lx = (301 - 320) * p->lz;
				p->ly = (184 - 179) * p->lz;
				if ((fabs (p->vz) < P3_V) && (fabs (p->lz) < P3_L)) {
					p->cyc++;	/*  */
					p->lx = 0.0;
					p->ly = 0.0;
					p->vx = 0.0;
					p->vy = 0.0;
				}
				break;
			default:
				break;
			}
			DispSp (p, 12, parts5_table);
			break;
		case 6:	/* Ep[c */
			switch (p->cyc) {
			case 0:
				if (seq_counter > P3_S) {
					p->cyc++;	/*  */
					p->lz = 0.0;	/* n_ 0.0, I_ 1.0 */
					p->vz = 0.0;
				}
				break;
			case 1:/* xIɗ */
				if (p->vz < 0.20)
					p->vz += 0.10;
				p->lz += p->vz;
				p->lx = -(301 - 320) * p->lz;
				p->ly = (184 - 179) * p->lz;
				if (p->lz > 1.0) {
					p->cyc++;	/*  */
					p->lz = 0.0;
					p->lx = 0.0;	/* x͂_ɂȂ */
					p->ly = 0.0;
					p->ox -= (301 - 320);
					p->oy += (184 - 179);
				}
				break;
			case 2:/* ΂ːU */
				p->vz -= p->lz * P3_K;
			    /* C */
				if (p->vz > 0)
					p->vz -= P3_M;
				else
					p->vz += P3_M;
				p->lz += p->vz;
				p->lx = -(301 - 320) * p->lz;
				p->ly = (184 - 179) * p->lz;
				if ((fabs (p->vz) < P3_V) && (fabs (p->lz) < P3_L)) {
					p->cyc++;	/*  */
					p->lx = 0.0;
					p->ly = 0.0;
					p->vx = 0.0;
					p->vy = 0.0;
					end_of_data = !0;	/* I */
				}
				break;
			default:
				break;
			}
			DispSp (p, 12, parts6_table);
			break;
		case 7:	/* p[c */
			if (seq_counter == 3)
				erase_flag = !0;
			else
				DispSp (p, 12, parts7_table);
			break;
		default:
			printf ("enemy_move() : oOĂ܂\n");
			break;
		}

		if (erase_flag) {
			if (q == NULL) {	/* Xg̈ԍŏ폜 */
				enemy_top = p->next;
				p->next = enemy_null_top;
				enemy_null_top = p;
				q = NULL;
				p = enemy_top;
			} else {
				q->next = p->next;
				p->next = enemy_null_top;
				enemy_null_top = p;
				p = q->next;
			}
		} else {
			q = p;
			p = p->next;
		}
	}
}


void EnemyTini (void)
{
	int i;

    /* XgȂ */
	enemy_top = NULL;
	enemy_null_top = enemy;
	for (i = 0; i < ENEMY_MAX; i++)
		enemy[i].next = &enemy[i + 1];

	enemy[ENEMY_MAX - 1].next = NULL;
}
